
	DDSCL_FULLSCREEN			EQU 00000001h
	DDSCL_ALLOWREBOOT			EQU 00000002h
	DDSCL_NOWINDOWCHANGES			EQU 00000004h
	DDSCL_NORMAL				EQU 00000008h
	DDSCL_EXCLUSIVE				EQU 00000010h
	DDSCL_ALLOWMODEX			EQU 00000040h
	DDSCL_SETFOCUSWINDOW			EQU 00000080h
	DDSCL_SETDEVICEWINDOW			EQU 00000100h
	DDSCL_CREATEDEVICEWINDOW		EQU 00000200h
	DDSCL_MULTITHREADED			EQU 00000400h
	DDSCL_FPUSETUP				EQU 00000800h
	DDSCL_FPUPRESERVE			EQU 00001000h

	DD_OK					EQU 0
	DD_FALSE				EQU S_FALSE

	FACILITY_DDRAWX				EQU 0876h
	FACILITY_D3DX				EQU 0877h

	DDERR_ALREADYINITIALIZED		EQU 088760005h
	DDERR_CANNOTATTACHSURFACE		EQU 08876000Ah
	DDERR_CANNOTDETACHSURFACE		EQU 088760014h
	DDERR_CURRENTLYNOTAVAIL			EQU 088760028h
	DDERR_EXCEPTION				EQU 088760037h
	DDERR_GENERIC				EQU 080004005h
	DDERR_HEIGHTALIGN			EQU 08876005Ah
	DDERR_INCOMPATIBLEPRIMARY		EQU 08876005Fh
	DDERR_INVALIDCAPS			EQU 088760064h
	DDERR_INVALIDCLIPLIST			EQU 08876006Eh
	DDERR_INVALIDMODE			EQU 088760078h
	DDERR_INVALIDOBJECT			EQU 088760082h
	DDERR_INVALIDPARAMS			EQU 080070057h
	DDERR_INVALIDPIXELFORMAT		EQU 088760091h
	DDERR_INVALIDRECT			EQU 088760096h
	DDERR_LOCKEDSURFACES			EQU 0887600A0h
	DDERR_NO3D				EQU 0887600AAh
	DDERR_NOALPHAHW				EQU 0887600B4h
	DDERR_NOSTEREOHARDWARE			EQU 0887600B5h
	DDERR_NOSURFACELEFT			EQU 0887600B6h
	DDERR_NOCLIPLIST			EQU 0887600CDh
	DDERR_NOCOLORCONVHW			EQU 0887600D2h
	DDERR_NOCOOPERATIVELEVELSET		EQU 0887600D4h
	DDERR_NOCOLORKEY			EQU 0887600D7h
	DDERR_NOCOLORKEYHW			EQU 0887600DCh
	DDERR_NODIRECTDRAWSUPPORT		EQU 0887600DEh
	DDERR_NOEXCLUSIVEMODE			EQU 0887600E1h
	DDERR_NOFLIPHW				EQU 0887600E6h
	DDERR_NOGDI				EQU 0887600F0h
	DDERR_NOMIRRORHW			EQU 0887600FAh
	DDERR_NOTFOUND				EQU 0887600FFh
	DDERR_NOOVERLAYHW			EQU 088760104h
	DDERR_OVERLAPPINGRECTS			EQU 08876010Eh
	DDERR_NORASTEROPHW			EQU 088760118h
	DDERR_NOROTATIONHW			EQU 088760122h
	DDERR_NOSTRETCHHW			EQU 088760136h
	DDERR_NOT4BITCOLOR			EQU 08876013Ch
	DDERR_NOT4BITCOLORINDEX			EQU 08876013Dh
	DDERR_NOT8BITCOLOR			EQU 088760140h
	DDERR_NOTEXTUREHW			EQU 08876014Ah
	DDERR_NOVSYNCHW				EQU 08876014Fh
	DDERR_NOZBUFFERHW			EQU 088760154h
	DDERR_NOZOVERLAYHW			EQU 08876015Eh
	DDERR_OUTOFCAPS				EQU 088760168h
	DDERR_OUTOFMEMORY			EQU 08007000Eh
	DDERR_OUTOFVIDEOMEMORY			EQU 08876017Ch
	DDERR_OVERLAYCANTCLIP			EQU 08876017Eh
	DDERR_OVERLAYCOLORKEYONLYONEACTIVE	EQU 088760180h
	DDERR_PALETTEBUSY			EQU 088760183h
	DDERR_COLORKEYNOTSET			EQU 088760190h
	DDERR_SURFACEALREADYATTACHED		EQU 08876019Ah
	DDERR_SURFACEALREADYDEPENDENT		EQU 0887601A4h
	DDERR_SURFACEBUSY			EQU 0887601AEh
	DDERR_CANTLOCKSURFACE			EQU 0887601B3h
	DDERR_SURFACEISOBSCURED			EQU 0887601B8h
	DDERR_SURFACELOST			EQU 0887601C2h
	DDERR_SURFACENOTATTACHED		EQU 0887601CCh
	DDERR_TOOBIGHEIGHT			EQU 0887601D6h
	DDERR_TOOBIGSIZE			EQU 0887601E0h
	DDERR_TOOBIGWIDTH			EQU 0887601EAh
	DDERR_UNSUPPORTED			EQU 080004001h
	DDERR_UNSUPPORTEDFORMAT			EQU 0887601FEh
	DDERR_UNSUPPORTEDMASK			EQU 088760208h
	DDERR_INVALIDSTREAM			EQU 088760209h
	DDERR_VERTICALBLANKINPROGRESS		EQU 088760219h
	DDERR_WASSTILLDRAWING			EQU 08876021Ch
	DDERR_DDSCAPSCOMPLEXREQUIRED		EQU 08876021Eh
	DDERR_XALIGN				EQU 088760230h
	DDERR_INVALIDDIRECTDRAWGUID		EQU 088760231h
	DDERR_DIRECTDRAWALREADYCREATED		EQU 088760232h
	DDERR_NODIRECTDRAWHW			EQU 088760233h
	DDERR_PRIMARYSURFACEALREADYEXISTS	EQU 088760234h
	DDERR_NOEMULATION			EQU 088760235h
	DDERR_REGIONTOOSMALL			EQU 088760236h
	DDERR_CLIPPERISUSINGHWND		EQU 088760237h
	DDERR_NOCLIPPERATTACHED			EQU 088760238h
	DDERR_NOHWND				EQU 088760239h
	DDERR_HWNDSUBCLASSED			EQU 08876023Ah
	DDERR_HWNDALREADYSET			EQU 08876023Bh
	DDERR_NOPALETTEATTACHED			EQU 08876023Ch
	DDERR_NOPALETTEHW			EQU 08876023Dh
	DDERR_BLTFASTCANTCLIP			EQU 08876023Eh
	DDERR_NOBLTHW				EQU 08876023Fh
	DDERR_NODDROPSHW			EQU 088760240h
	DDERR_OVERLAYNOTVISIBLE			EQU 088760241h
	DDERR_NOOVERLAYDEST			EQU 088760242h
	DDERR_INVALIDPOSITION			EQU 088760243h
	DDERR_NOTAOVERLAYSURFACE		EQU 088760244h
	DDERR_EXCLUSIVEMODEALREADYSET		EQU 088760245h
	DDERR_NOTFLIPPABLE			EQU 088760246h
	DDERR_CANTDUPLICATE			EQU 088760247h
	DDERR_NOTLOCKED				EQU 088760248h
	DDERR_CANTCREATEDC			EQU 088760249h
	DDERR_NODC				EQU 08876024Ah
	DDERR_WRONGMODE				EQU 08876024Bh
	DDERR_IMPLICITLYCREATED			EQU 08876024Ch
	DDERR_NOTPALETTIZED			EQU 08876024Dh
	DDERR_UNSUPPORTEDMODE			EQU 08876024Eh
	DDERR_NOMIPMAPHW			EQU 08876024Fh
	DDERR_INVALIDSURFACETYPE		EQU 088760250h
	DDERR_NOOPTIMIZEHW			EQU 088760258h
	DDERR_NOTLOADED				EQU 088760259h
	DDERR_NOFOCUSWINDOW			EQU 08876025Ah
	DDERR_NOTONMIPMAPSUBLEVEL		EQU 08876025Bh
	DDERR_DCALREADYCREATED			EQU 08876026Ch
	DDERR_NONONLOCALVIDMEM			EQU 088760276h
	DDERR_CANTPAGELOCK			EQU 088760280h
	DDERR_CANTPAGEUNLOCK			EQU 088760294h
	DDERR_NOTPAGELOCKED			EQU 0887602A8h
	DDERR_MOREDATA				EQU 0887602B2h
	DDERR_EXPIRED				EQU 0887602B3h
	DDERR_TESTFINISHED			EQU 0887602B4h
	DDERR_NEWMODE				EQU 0887602B5h
	DDERR_D3DNOTINITIALIZED			EQU 0887602B6h
	DDERR_VIDEONOTACTIVE			EQU 0887602B7h
	DDERR_NOMONITORINFORMATION		EQU 0887602B8h
	DDERR_NODRIVERSUPPORT			EQU 0887602B9h
	DDERR_DEVICEDOESNTOWNSURFACE		EQU 0887602BBh

	D3DXERR_NOMEMORY			EQU 0C8770BB8h
	D3DXERR_NULLPOINTER			EQU 0C8770BB9h
	D3DXERR_INVALIDD3DXDEVICEINDEX		EQU 0C8770BBAh
	D3DXERR_NODIRECTDRAWAVAILABLE		EQU 0C8770BBBh
	D3DXERR_NODIRECT3DAVAILABLE		EQU 0C8770BBCh
	D3DXERR_NODIRECT3DDEVICEAVAILABLE	EQU 0C8770BBDh
	D3DXERR_NOPRIMARYAVAILABLE		EQU 0C8770BBEh
	D3DXERR_NOZBUFFERAVAILABLE		EQU 0C8770BBFh
	D3DXERR_NOBACKBUFFERAVAILABLE		EQU 0C8770BC0h
	D3DXERR_COULDNTUPDATECAPS		EQU 0C8770BC1h
	D3DXERR_NOZBUFFER			EQU 0C8770BC2h
	D3DXERR_INVALIDMODE			EQU 0C8770BC3h
	D3DXERR_INVALIDPARAMETER		EQU 0C8770BC4h
	D3DXERR_INITFAILED			EQU 0C8770BC5h
	D3DXERR_STARTUPFAILED			EQU 0C8770BC6h
	D3DXERR_D3DXNOTSTARTEDYET		EQU 0C8770BC7h
	D3DXERR_NOTINITIALIZED			EQU 0C8770BC8h
	D3DXERR_FAILEDDRAWTEXT			EQU 0C8770BC9h
	D3DXERR_BADD3DXCONTEXT			EQU 0C8770BCAh
	D3DXERR_CAPSNOTSUPPORTED		EQU 0C8770BCBh
	D3DXERR_UNSUPPORTEDFILEFORMAT		EQU 0C8770BCCh
	D3DXERR_IFLERROR			EQU 0C8770BCDh
	D3DXERR_FAILEDGETCAPS			EQU 0C8770BCEh
	D3DXERR_CANNOTRESIZEFULLSCREEN		EQU 0C8770BCFh
	D3DXERR_CANNOTRESIZENONWINDOWED		EQU 0C8770BD0h
	D3DXERR_FRONTBUFFERALREADYEXISTS	EQU 0C8770BD1h
	D3DXERR_FULLSCREENPRIMARYEXISTS		EQU 0C8770BD2h
	D3DXERR_GETDCFAILED			EQU 0C8770BD3h
	D3DXERR_BITBLTFAILED			EQU 0C8770BD4h
	D3DXERR_NOTEXTURE			EQU 0C8770BD5h
	D3DXERR_MIPLEVELABSENT			EQU 0C8770BD6h
	D3DXERR_SURFACENOTPALETTED		EQU 0C8770BD7h
	D3DXERR_ENUMFORMATSFAILED		EQU 0C8770BD8h
	D3DXERR_COLORDEPTHTOOLOW		EQU 0C8770BD9h
	D3DXERR_INVALIDFILEFORMAT		EQU 0C8770BDAh
	D3DXERR_NOMATCHFOUND			EQU 0C8770BDBh

	comethod1Proto	TYPEDEF PROTO :DWORD
	comethod2Proto	TYPEDEF PROTO :DWORD,:DWORD
	comethod3Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD
	comethod4Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD
	comethod5Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	comethod6Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	comethod7Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	comethod8Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	comethod9Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	comethod10Proto	TYPEDEF PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

	comethod1	TYPEDEF PTR comethod1Proto
	comethod2	TYPEDEF PTR comethod2Proto
	comethod3	TYPEDEF PTR comethod3Proto
	comethod4	TYPEDEF PTR comethod4Proto
	comethod5	TYPEDEF PTR comethod5Proto
	comethod6	TYPEDEF PTR comethod6Proto
	comethod7	TYPEDEF PTR comethod7Proto
	comethod8	TYPEDEF PTR comethod8Proto
	comethod9	TYPEDEF PTR comethod9Proto
	comethod10	TYPEDEF PTR comethod10Proto


IDirectDraw	STRUCT

	; IUnknown methods
		QueryInterface		comethod3 ?
		AddRef			comethod1 ?
		Release			comethod1 ?
	; IDirectDraw methods
		Compact			comethod1 ?
		CreateClipper		comethod4 ?
		CreatePalette		comethod5 ?
		CreateSurface		comethod4 ?
		DuplicateSurface	comethod3 ?
		EnumDisplayModes	comethod5 ?
		EnumSurfaces		comethod5 ?
		FlipToGDISurface	comethod1 ?
		GetCaps			comethod3 ?
		GetDisplayMode		comethod2 ?
		GetFourCCCodes		comethod3 ?
		GetGDISurface		comethod2 ?
		GetMonitorFrequency	comethod2 ?
		GetScanLine		comethod2 ?
		GetVerticalBlankStatus	comethod2 ?
		Initialize		comethod2 ?
		RestoreDisplayMode	comethod1 ?
		SetCooperativeLevel	comethod3 ?
		SetDisplayMode		comethod6 ?
		WaitForVerticalBlank	comethod3 ?

IDirectDraw	ENDS



IDirectDraw7	STRUCT

	; IUnknown methods
		QueryInterface		comethod3 ?
		AddRef			comethod1 ?
		Release			comethod1 ?
	; IDirectDraw methods
		Compact			comethod1 ?
		CreateClipper		comethod4 ?
		CreatePalette		comethod5 ?
		CreateSurface		comethod4 ?
		DuplicateSurface	comethod3 ?
		EnumDisplayModes	comethod5 ?
		EnumSurfaces		comethod5 ?
		FlipToGDISurface	comethod1 ?
		GetCaps			comethod3 ?
		GetDisplayMode		comethod2 ?
		GetFourCCCodes		comethod3 ?
		GetGDISurface		comethod2 ?
		GetMonitorFrequency	comethod2 ?
		GetScanLine		comethod2 ?
		GetVerticalBlankStatus	comethod2 ?
		Initialize		comethod2 ?
		RestoreDisplayMode	comethod1 ?
		SetCooperativeLevel	comethod3 ?
		SetDisplayMode		comethod6 ?
		WaitForVerticalBlank	comethod3 ?
	; IDirectDraw2 methods
		GetAvailableVidMem	comethod4 ?
	; IDirectDraw4 methods
		GetSurfaceFromDC	comethod3 ?
		RestoreAllSurfaces	comethod1 ?
		TestCooperativeLevel	comethod1 ?
		GetDeviceIdentifier	comethod3 ?
	; IDirectDraw7 methods
		StartModeTest		comethod4 ?
		EvaluateMode		comethod3 ?
IDirectDraw7	ENDS


coinvoke MACRO pInterface:REQ, Interface:REQ, Function:REQ, args:VARARG
LOCAL istatement, arg

FOR arg, <args> ;; run thru args to see if edx is lurking in there
IFIDNI <&arg>, <edx>
.ERR <edx is not allowed as a coinvoke parameter>
ENDIF
ENDM
IFIDNI <&pInterface>, <edx>
.ERR <edx is not allowed as a coinvoke parameter>
ENDIF
istatement CATSTR <invoke (Interface PTR [edx]).>,<&Function, pInterface>
IFNB <args> ; add the list of parameter arguments if any
istatement CATSTR istatement, <, >, <&args> 
ENDIF 
mov edx, pInterface
mov edx, [edx]	; virtual function table address
istatement

ENDM